Index: /code/branches/spaceNavigation/data/overlays/HUD.oxo
===================================================================
--- /code/branches/spaceNavigation/data/overlays/HUD.oxo	(revision 9428)
+++ /code/branches/spaceNavigation/data/overlays/HUD.oxo	(revision 9429)
@@ -52,5 +52,5 @@
    value      = 0
   >
-    <BarColour position = 0.7 colour = "0.2,0.7,0.2" />
+    <BarColounar position = 0.7 colour = "0.2,0.7,0.2" />
     <BarColour position = 0.4 colour = "0.7,0.5,0.2" />
     <BarColour position = 0.1 colour = "0.7,0.2,0.2" />
@@ -63,5 +63,5 @@
    textSize      = 0.05
    navMarkerSize = 0.03
-   aimMarkerSize = 0.04
+   aimMarkerSize = 0.02
   />
 
Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9428)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9429)
@@ -72,10 +72,12 @@
         this->setTextSize(0.05f);
         this->setNavMarkerSize(0.05f);
+        this->setAimMarkerSize(0.02f);
+
         this->setDetectionLimit(10000.0f);
         this->currentMunitionSpeed_ = 2500.0f;
 
-        Pawn* ship = orxonox_cast<Pawn*>(this->getOwner());
+        /*Pawn* ship = orxonox_cast<Pawn*>(this->getOwner());
         if(ship != NULL)
-            this->ship_ = ship;
+            this->ship_ = ship;*/
     }
 
@@ -104,4 +106,5 @@
         XMLPortParam(HUDNavigation, "navMarkerSize", setNavMarkerSize, getNavMarkerSize, xmlelement, mode);
         XMLPortParam(HUDNavigation, "detectionLimit", setDetectionLimit, getDetectionLimit, xmlelement, mode);
+        XMLPortParam(HUDNavigation, "aimMarkerSize", setAimMarkerSize, getAimMarkerSize, xmlelement, mode);
     }
 
@@ -290,4 +293,5 @@
                         it->second.panel_->setMaterialName(TextureGenerator::getMaterialName("tdc.png", it->first->getRadarObjectColour()));
                         it->second.panel_->setDimensions(this->navMarkerSize_ * this->getActualSize().x, this->navMarkerSize_ * this->getActualSize().y);
+                        it->second.target_->setDimensions(aimMarkerSize_ * this->getActualSize().x, this->aimMarkerSize_ * this->getActualSize().y);
                         it->second.wasOutOfView_ = false;
                     }
@@ -298,5 +302,9 @@
                     it->second.panel_->setTop((-pos.y + 1.0f - it->second.panel_->getHeight()) * 0.5f);
 
-                    // TODO : Target marker
+                    // Position text
+                    it->second.text_->setLeft((pos.x + 1.0f + it->second.panel_->getWidth()) * 0.5f);
+                    it->second.text_->setTop((-pos.y + 1.0f + it->second.panel_->getHeight()) * 0.5f);
+
+                    // Target marker
                     Vector3* targetPos = this->toAimPosition(it->first);
                     Vector3 screenPos = camTransform * *targetPos;
@@ -309,15 +317,10 @@
                     else
                     {
-                        it->second.target_->show();
                         it->second.target_->setLeft((screenPos.x + 1.0f - it->second.target_->getWidth()) * 0.5f);
                         it->second.target_->setTop((-screenPos.y + 1.0f - it->second.target_->getHeight()) * 0.5f);
-                    }
-
-                    orxout() << targetPos->x << endl;
+                        it->second.target_->show();
+                    }
+
                     delete targetPos;
-
-                    // Position text
-                    it->second.text_->setLeft((pos.x + 1.0f + it->second.panel_->getWidth()) * 0.5f);
-                    it->second.text_->setTop((-pos.y + 1.0f + it->second.panel_->getHeight()) * 0.5f);
                 }
 
@@ -331,5 +334,5 @@
                 it->second.panel_->hide();
                 it->second.text_->hide();
-                it->second.target_->hide(); // TODO :
+                it->second.target_->hide();
             }
         }
@@ -354,6 +357,5 @@
                 it->second.text_->setCharHeight(it->second.text_->getCharHeight() * yScale);
             if (it->second.target_ != NULL)
-                it->second.target_->setDimensions(this->navMarkerSize_ * xScale, this->navMarkerSize_ * yScale);
-            // TODO : targetMarkerSize_ ???
+                it->second.target_->setDimensions(this->aimMarkerSize_ * xScale, this->aimMarkerSize_ * yScale);
         }
     }
@@ -388,6 +390,6 @@
         Ogre::PanelOverlayElement* target = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
                 .createOverlayElement("Panel", "HUDNavigation_targetMarker_" + getUniqueNumberString()));
-        target->setMaterialName(TextureGenerator::getMaterialName("target.png" /* TODO : create the target picture */, object->getRadarObjectColour()));
-        target->setDimensions(this->navMarkerSize_ * xScale, this->navMarkerSize_ * yScale);
+        target->setMaterialName(TextureGenerator::getMaterialName("target.png", object->getRadarObjectColour()));
+        target->setDimensions(this->aimMarkerSize_ * xScale, this->aimMarkerSize_ * yScale);
 
         // Create text
Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9428)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9429)
@@ -91,4 +91,11 @@
             inline float getNavMarkerSize() const
                 { return navMarkerSize_; }
+            inline void setAimMarkerSize(float size)
+            {
+                aimMarkerSize_ = size;
+                this->sizeChanged();
+            }
+            inline float getAimMarkerSize() const
+                { return aimMarkerSize_; }
             inline void setDetectionLimit(float limit)
                 { this->detectionLimit_ = limit; }
@@ -111,4 +118,5 @@
 
             float navMarkerSize_;
+            float aimMarkerSize_;
             std::string fontName_;
             float textSize_;