Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9433)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9434)
@@ -203,4 +203,12 @@
                     it->second.text_->setCaption(it->first->getRadarName());
                     textLength = it->first->getRadarName().size() * it->second.text_->getCharHeight() * 0.3f;
+                }
+
+                // TODO : closest object is selected
+                if(listIt == this->sortedObjectList_.begin())
+                {
+                    it->second.selected_ = true;
+                } else {
+                    it->second.selected_ = false;
                 }
 
@@ -293,5 +301,5 @@
                         it->second.panel_->setMaterialName(TextureGenerator::getMaterialName("tdc.png", it->first->getRadarObjectColour()));
                         it->second.panel_->setDimensions(this->navMarkerSize_ * this->getActualSize().x, this->navMarkerSize_ * this->getActualSize().y);
-                        it->second.target_->setDimensions(aimMarkerSize_ * this->getActualSize().x, this->aimMarkerSize_ * this->getActualSize().y);
+                        it->second.target_->setDimensions(this->aimMarkerSize_ * this->getActualSize().x, this->aimMarkerSize_ * this->getActualSize().y);
                         it->second.wasOutOfView_ = false;
                     }
@@ -307,20 +315,25 @@
 
                     // Target marker
-                    Vector3* targetPos = this->toAimPosition(it->first);
-                    Vector3 screenPos = camTransform * *targetPos;
-                    // Check if the target marker is in view too
-                    if(screenPos.z > 1 || screenPos.x < -1.0 || screenPos.x > 1.0
-                            || screenPos.y < -1.0 || screenPos.y > 1.0)
+                    if(it->second.selected_)
                     {
+                        Vector3* targetPos = this->toAimPosition(it->first);
+                        Vector3 screenPos = camTransform * *targetPos;
+                        // Check if the target marker is in view too
+                        if(screenPos.z > 1 || screenPos.x < -1.0 || screenPos.x > 1.0
+                                || screenPos.y < -1.0 || screenPos.y > 1.0)
+                        {
+                            it->second.target_->hide();
+                        }
+                        else
+                        {
+                            it->second.target_->setLeft((screenPos.x + 1.0f - it->second.target_->getWidth()) * 0.5f);
+                            it->second.target_->setTop((-screenPos.y + 1.0f - it->second.target_->getHeight()) * 0.5f);
+                            it->second.target_->show();
+                        }
+
+                        delete targetPos;
+                    }
+                    else // don't show marker for not selected enemies
                         it->second.target_->hide();
-                    }
-                    else
-                    {
-                        it->second.target_->setLeft((screenPos.x + 1.0f - it->second.target_->getWidth()) * 0.5f);
-                        it->second.target_->setTop((-screenPos.y + 1.0f - it->second.target_->getHeight()) * 0.5f);
-                        it->second.target_->show();
-                    }
-
-                    delete targetPos;
                 }
 
@@ -405,5 +418,5 @@
 
         ObjectInfo tempStruct =
-        {   panel, target, text, false /*, TODO: initialize wasOutOfView_ */};
+        {   panel, target, text, false, false, false};
         this->activeObjectList_[object] = tempStruct;
 
Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9433)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9434)
@@ -79,4 +79,5 @@
                 bool outOfView_;
                 bool wasOutOfView_;
+                bool selected_;
             };
 