Index: branches/proxy/src/util/Makefile.am
===================================================================
--- branches/proxy/src/util/Makefile.am	(revision 9435)
+++ branches/proxy/src/util/Makefile.am	(revision 9437)
@@ -26,7 +26,5 @@
 			animation/animation_player.cc \
 			\
-			track/pilot_node.cc \
-			\
-			network_stats_widget.cc
+			track/pilot_node.cc
 
 #			track/track_manager.cc \
@@ -54,8 +52,5 @@
 			animation/t_animation.h \
 			\
-			track/pilot_node.h \
-			\
-			network_stats_widget.h
-
+			track/pilot_node.h
 
 #			track/track_manager.h \
Index: branches/proxy/src/util/network_stats_widget.cc
===================================================================
--- branches/proxy/src/util/network_stats_widget.cc	(revision 9435)
+++ 	(revision )
@@ -1,221 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Benjamin Grauer
-   co-programmer: ...
-*/
-
-//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
-
-#include "network_stats_widget.h"
-
-#include "multi_type.h"
-
-#include "shell_command.h"
-//#include "network_monitor.h"
-
-namespace OrxGui
-{
-  SHELL_COMMAND(gui, NetworkStatsWidget, gui);
-
-
-  HostWidget::HostWidget(const std::string& name, const IP& ip)
-      : GLGuiBox(Horizontal)
-  {
-    this->setName(name);
-    this->setIP(ip);
-
-    this->pack(&this->_name);
-    this->pack(&this->_ip);
-  }
-
-  void HostWidget::showing()
-  {
-    this->_name.show();
-    this->_ip.show();
-  }
-
-  void HostWidget::hiding()
-  {
-    this->_name.hide();
-    this->_ip.hide();
-  }
-
-
-
-  //======================================================//
-
-
-  ProxyWidget::ProxyWidget(const std::string& proxyName, const IP& ip)
-  : _proxyWidget(proxyName, ip)
-  {
-    this->_clientNameWidth = 100.0f;
-    this->pack(&_proxyWidget);
-  }
-
-  void ProxyWidget::addClient(const std::string& name, const IP& ip)
-  {
-    HostWidget* newClient = new HostWidget(name, ip);
-    newClient->setNameWidth(this->_clientNameWidth);
-
-    this->pack(newClient);
-
-    if (this->isVisible())
-      newClient->show();
-  }
-
-  bool ProxyWidget::removeClient(const IP& ip)
-  {
-    std::vector<HostWidget*>::iterator rmIt;
-    for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-    {
-      if (*(*rmIt) == ip)
-      {
-        delete (*rmIt);
-        this->_clients.erase(rmIt);
-        return true;
-      }
-    }
-    return false;
-  }
-
-  bool ProxyWidget::removeClient(const std::string& name)
-  {
-    std::vector<HostWidget*>::iterator rmIt;
-    for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-    {
-      if (*(*rmIt) == name)
-      {
-        delete (*rmIt);
-        this->_clients.erase(rmIt);
-        return true;
-      }
-    }
-    return false;
-
-  }
-
-  bool ProxyWidget::removeClient(const std::string& name, const IP& ip)
-  {
-    std::vector<HostWidget*>::iterator rmIt;
-    for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
-    {
-      if (*(*rmIt) == ip && *(*rmIt) == name)
-      {
-        delete (*rmIt);
-        this->_clients.erase(rmIt);
-        return true;
-      }
-    }
-    return false;
-  }
-
-
-  void ProxyWidget::setClientNameWidths(float width)
-  {
-    this->_clientNameWidth = width;
-    for (unsigned int i = 0; i < this->_clients.size(); ++i)
-      this->_clients[i]->setNameWidth(width);
-  }
-
-  void ProxyWidget::hiding()
-  {
-    this->_proxyWidget.hide();
-    for (unsigned int i = 0; i < this->_clients.size(); ++i)
-      this->_clients[i]->hide();
-  }
-
-  void ProxyWidget::showing()
-  {
-    this->_proxyWidget.show();
-    for (unsigned int i = 0; i < this->_clients.size(); ++i)
-      this->_clients[i]->show();
-  }
-
-
-  //======================================================//
-
-
-  void NetworkStatsWidget::gui()
-  {
-    printf("YEAH\n");
-  }
-
-
-  /**
-   * @brief standard constructor
-   */
-  NetworkStatsWidget::NetworkStatsWidget ()
-  : GLGuiBox(Vertical), _thisHost("myName", IP(127, 0, 0 , 0))
-  {
-    //   this->setClassID(CL_PROTO_ID, "NetworkStatsWidget");
-
-    this->_bar.setSize2D(100, 30);
-    this->pack(&this->_valueText);
-    this->_bar.setParent2D(&this->_valueText);
-
-    this->_valueText.setChangedTextColor(Color::white);
-
-    //this->setBackgroundTexture("maps/gui_element_background_2.png");
-    this->setBackgroundColor(Color(.5,.5,.5,1));
-
-    //this->_name.setBackgroundTexture(Texture());
-    //this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
-    this->_bar.setBackgroundTexture(Texture());
-    this->_bar.setBackgroundColor(Color(0,0,0,0));
-    this->_bar.setForegroundTexture("maps/gui_element_background_faded.png");
-    this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
-    this->_bar.setChangedValueColor(Color::black);
-  }
-
-
-  /**
-   * @brief standard deconstructor
-   */
-  NetworkStatsWidget::~NetworkStatsWidget ()
-  {}
-
-
-  void NetworkStatsWidget::setMaximum(float max)
-  {
-    this->_bar.setMaximum(max);
-  }
-
-  void NetworkStatsWidget::setValue(float value)
-  {
-    MultiType val(value);
-    val.setType(MT_INT);
-
-
-    this->_bar.setValue(value);
-    this->_bar.setForegroundColor(Color::slerpHSVColor(Color::red, Color::green, value/this->_bar.maximum()));
-    this->_bar.setFrontColor(Color(1,1,1,1), true);
-    this->_valueText.setText(val.getString());
-  }
-
-  void NetworkStatsWidget::resize()
-  {
-    GLGuiBox::resize();
-  }
-
-
-  void NetworkStatsWidget::showing()
-  {
-    this->_valueText.show();
-    this->_bar.show();
-  }
-
-  void NetworkStatsWidget::hiding()
-  {
-    this->_valueText.hide();
-    this->_bar.hide();
-  }
-}
Index: branches/proxy/src/util/network_stats_widget.h
===================================================================
--- branches/proxy/src/util/network_stats_widget.h	(revision 9435)
+++ 	(revision )
@@ -1,117 +1,0 @@
-/*!
- * @file network_stats_widget.h
- * @brief Definition of an EnergyWidget, that displays a bar and a Text
-*/
-
-#ifndef _NETWORK_STATS_WIDGET_H
-#define _NETWORK_STATS_WIDGET_H
-
-#include "glgui_box.h"
-#include "glgui_bar.h"
-#include "glgui_text.h"
-
-#include "network/ip.h"
-
-
-namespace OrxGui
-{
-
-  class HostWidget : public GLGuiBox
-  {
-    public:
-      HostWidget(const std::string& name, const IP& ip);
-      ~HostWidget() {};
-
-      void setName(const std::string& name) { this->_name.setText(name); };
-      void setIP(const IP& ip) { this->_ip.setText(ip.ipString()); this->_storedIP = ip; };
-
-      void setNameWidth(float width) { this->_name.setLineWidth(width); };
-
-      bool operator==(const IP& ip) const { return (this->_storedIP == ip); };
-      bool operator==(const std::string& name) const { return (this->_name == name); };
-
-    protected:
-      virtual void showing();
-      virtual void hiding();
-
-    private:
-      GLGuiText        _name;           //!< The Name of the Proxy server to be displayed.
-      GLGuiText        _ip;             //!< The IP of the proxy server.
-      IP               _storedIP;       //!< The ip to compare.
-  };
-
-
-  class ProxyWidget : public GLGuiBox
-  {
-    public:
-      ProxyWidget(const std::string& proxyName, const IP& ip);
-
-      void addClient(const std::string& name, const IP& ip);
-
-      bool removeClient(const IP& ip);
-      bool removeClient(const std::string& name);
-      bool removeClient(const std::string& name, const IP& ip);
-
-      void setClientNameWidths(float width);
-
-
-    protected:
-      virtual void hiding();
-      virtual void showing();
-
-
-    private:
-      HostWidget                _proxyWidget;
-
-      std::vector<HostWidget*>  _clients;
-      float                     _clientNameWidth;
-  };
-
-
-
-
-  //! A class to display network Statistics.
-  class NetworkStatsWidget : public GLGuiBox
-  {
-    public:
-      static void gui();
-
-    public:
-      NetworkStatsWidget();
-      virtual ~NetworkStatsWidget();
-
-      void setUpstream(unsigned int upstream);
-      void setDownstream(unsigned int upstream);
-      void setIP(const IP& ip);
-
-
-
-      void addProxy(const std::string& name, const IP& proxy);
-
-
-      //void rebuildConnectedHosts(std::vector<hosts> hosts);
-
-      void setMaximum(float max);
-      void setValue(float value);
-
-    protected:
-      virtual void resize();
-      virtual void showing();
-      virtual void hiding();
-
-    private:
-      HostWidget             _thisHost;
-
-      GLGuiText              _upstreamText;
-      GLGuiText              _downstreamText;
-
-      std::vector<HostWidget*>_connectedProxies;
-
-      GLGuiText              _serverIP;
-
-
-      GLGuiText              _valueText;
-      GLGuiBar               _bar;
-  };
-}
-#endif /* _NETWORK_STATS_WIDGET_H */