Index: /branches/proxy/src/lib/network/monitor/network_monitor.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9437)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9438)
@@ -31,6 +31,7 @@
 
 
-SHELL_COMMAND(showGUI, NetworkMonitor, showGUI);
-SHELL_COMMAND(hideGUI, NetworkMonitor, hideGUI);
+#include "network_stats_widget.h"
+
+SHELL_COMMAND(gui, NetworkMonitor, toggleGUI);
 SHELL_COMMAND(debug, NetworkMonitor, debug);
 
@@ -72,4 +73,5 @@
     }
   }
+  this->box = NULL;
 }
 
@@ -196,5 +198,5 @@
  * this displays the network monitor gui
  */
-void NetworkMonitor::showGUI()
+void NetworkMonitor::toggleGUI()
 {
   if (this->box == NULL)
@@ -202,36 +204,18 @@
     this->box = new OrxGui::GLGuiBox(OrxGui::Vertical);
     {
-      OrxGui::GLGuiBox* waterColorBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
-      {
-        OrxGui::GLGuiText* waterColorText = new OrxGui::GLGuiText();
-        waterColorText->setText("NetworkMonitor");
-        waterColorBox->pack(waterColorText);
-      }
-      this->box->pack(waterColorBox);
+      NetworkStatsWidget* netStats = new NetworkStatsWidget();
+      this->box->pack(netStats);
+
     }
 
     this->box->showAll();
     this->box->setAbsCoor2D(300, 40);
-    OrxGui::GLGuiHandler::getInstance()->activate();
-//     OrxGui::GLGuiHandler::getInstance()->activateCursor();
-  }
-}
-
-
-/**
- * hides the network monitor gui again
- */
-void NetworkMonitor::hideGUI()
-{
-  if( this->box == NULL)
-    return;
-
-  OrxGui::GLGuiHandler::getInstance()->deactivate();
-//   OrxGui::GLGuiHandler::getInstance()->deactivateCursor();
-
-  delete this->box;
-  this->box = NULL;
-}
-
+  }
+  else
+  {
+    delete this->box;
+    this->box = NULL;
+  }
+}
 
 /**
Index: /branches/proxy/src/lib/network/monitor/network_monitor.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9437)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9438)
@@ -74,6 +74,5 @@
 
 
-    void showGUI();
-    void hideGUI();
+    void toggleGUI();
 
     void process();
Index: /branches/proxy/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9437)
+++ /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9438)
@@ -19,10 +19,4 @@
 
 #include "multi_type.h"
-
-#include "shell_command.h"
-//#include "network_monitor.h"
-
-SHELL_COMMAND(gui, NetworkStatsWidget, gui);
-
 
 HostWidget::HostWidget(const std::string& name, const IP& ip)
@@ -142,11 +136,4 @@
 //======================================================//
 
-
-void NetworkStatsWidget::gui()
-{
-  printf("YEAH\n");
-}
-
-
 /**
  * @brief standard constructor
@@ -157,4 +144,5 @@
   //   this->setClassID(CL_PROTO_ID, "NetworkStatsWidget");
 
+  /*
   this->_bar.setSize2D(100, 30);
   this->pack(&this->_valueText);
@@ -173,4 +161,11 @@
   this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
   this->_bar.setChangedValueColor(Color::black);
+  */
+  this->pack(&this->_thisHost);
+
+  this->pack(&this->_upstreamText);
+  this->pack(&this->_downstreamText);
+
+  this->pack(&this->_serverIP);
 }
 
@@ -185,5 +180,5 @@
 void NetworkStatsWidget::setMaximum(float max)
 {
-  this->_bar.setMaximum(max);
+ // this->_bar.setMaximum(max);
 }
 
@@ -192,5 +187,5 @@
   MultiType val(value);
   val.setType(MT_INT);
-
+  /*
 
   this->_bar.setValue(value);
@@ -198,4 +193,5 @@
   this->_bar.setFrontColor(Color(1,1,1,1), true);
   this->_valueText.setText(val.getString());
+  */
 }
 
@@ -208,11 +204,7 @@
 void NetworkStatsWidget::showing()
 {
-  this->_valueText.show();
-  this->_bar.show();
 }
 
 void NetworkStatsWidget::hiding()
 {
-  this->_valueText.hide();
-  this->_bar.hide();
-}
+}
Index: /branches/proxy/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9437)
+++ /branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9438)
@@ -73,7 +73,4 @@
 {
   public:
-    void gui();
-
-  public:
     NetworkStatsWidget();
     virtual ~NetworkStatsWidget();
@@ -109,6 +106,6 @@
 
 
-    OrxGui::GLGuiText       _valueText;
-    OrxGui::GLGuiBar        _bar;
+    //OrxGui::GLGuiText       _valueText;
+    //OrxGui::GLGuiBar        _bar;
 };
 