Index: /code/branches/spaceNavigation/data/levels/missionOne.oxw
===================================================================
--- /code/branches/spaceNavigation/data/levels/missionOne.oxw	(revision 9442)
+++ /code/branches/spaceNavigation/data/levels/missionOne.oxw	(revision 9443)
@@ -636,9 +636,9 @@
 <!-- @Objects: 2 pirates moving in squares, nonlethal -->
                 <SpaceShip position="0,2000,200" lookat="0,0,0" name="movingtarget" radarname="Pirate">
-                            <events>
+                            <!--events>
                                 <visibility>
                                     <EventListener event="boxtrigger4" />
                                 </visibility>
-                            </events>
+                            </events-->
                     <templates>
                       <Template link=spaceshippirate />
@@ -657,9 +657,9 @@
 
                 <SpaceShip position="0,2000,400" lookat="0,0,0" name="movingtarget" radarname="Pirate">
-                            <events>
+                            <!--events>
                                 <visibility>
                                     <EventListener event="boxtrigger4" />
                                 </visibility>
-                            </events>
+                            </events-->
                   <templates>
                     <Template link=spaceshippirate />
Index: /code/branches/spaceNavigation/data/overlays/HUDTemplates3.oxo
===================================================================
--- /code/branches/spaceNavigation/data/overlays/HUDTemplates3.oxo	(revision 9442)
+++ /code/branches/spaceNavigation/data/overlays/HUDTemplates3.oxo	(revision 9443)
@@ -105,5 +105,5 @@
      textsize      = 0.05
      navMarkerSize = 0.03
-     aimMarkerSize = 0.04
+     aimMarkerSize = 0.02
     />
 
Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9442)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.cc	(revision 9443)
@@ -71,5 +71,5 @@
         this->setFont("Monofur");
         this->setTextSize(0.05f);
-        this->setNavMarkerSize(0.05f);
+        this->setNavMarkerSize(0.03f);
         this->setAimMarkerSize(0.02f);
 
@@ -180,4 +180,5 @@
         unsigned int markerCount = 0;
         bool closeEnough = false; // only display objects that are close enough to be relevant for the player
+
 
         for (std::list<std::pair<RadarViewable*, unsigned int> >::iterator listIt = this->sortedObjectList_.begin(); listIt != this->sortedObjectList_.end(); ++markerCount, ++listIt)
@@ -227,5 +228,5 @@
                 }
                 else
-                outOfView = pos.x < -1.0 || pos.x > 1.0 || pos.y < -1.0 || pos.y > 1.0;
+                    outOfView = pos.x < -1.0 || pos.x > 1.0 || pos.y < -1.0 || pos.y > 1.0;
 
                 if (outOfView)
@@ -315,8 +316,8 @@
 
                     // Target marker
-                    if(it->second.selected_)
+                    if(it->second.selected_ && it->first->getRVOrientedVelocity().squaredLength() != 0)
                     {
                         Vector3* targetPos = this->toAimPosition(it->first);
-                        Vector3 screenPos = camTransform * *targetPos;
+                        Vector3 screenPos = camTransform * (*targetPos);
                         // Check if the target marker is in view too
                         if(screenPos.z > 1 || screenPos.x < -1.0 || screenPos.x > 1.0
@@ -491,19 +492,20 @@
         // munSpeed*time = lengthBetween(wePosition, targetPosition + targetSpeed*time)
         // from this we extract:
-        float a = pow(targetSpeed.length(),2) - pow(this->currentMunitionSpeed_,2);
+        float a = targetSpeed.squaredLength() - this->currentMunitionSpeed_ * this->currentMunitionSpeed_;
         float b = 2*((targetPosition.x - wePosition.x)*targetSpeed.x
                     +(targetPosition.y - wePosition.y)*targetSpeed.y
                     +(targetPosition.z - wePosition.z)*targetSpeed.z);
-        float c = pow((targetPosition-wePosition).length(),2);
+        float c = (wePosition-targetPosition).squaredLength();
 
         // calculate smallest time solution, in case it exists
-        if(pow(b,2) - 4*a*c < 0)
+        float det = b * b - 4 * a * c;
+        if(det < 0)
             return NULL;
-        float time = (-b - sqrt(pow(b,2) - 4*a*c))/(2*a);
+        float time = (-b - sqrt(det))/(2*a);
         if(time < 0)
-            time = (-b + sqrt(pow(b,2) - 4*a*c))/(2*a);
+            time = (-b + sqrt(det))/(2*a);
         if(time < 0)
             return NULL;
-        Vector3* result = new Vector3(targetPosition + targetSpeed * time);
+        Vector3* result = new Vector3(targetPosition + time * targetSpeed);
         return result;
     }
Index: /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9442)
+++ /code/branches/spaceNavigation/src/modules/overlays/hud/HUDNavigation.h	(revision 9443)
@@ -87,5 +87,5 @@
             inline void setNavMarkerSize(float size)
             {
-                navMarkerSize_ = size;
+                this->navMarkerSize_ = size;
                 this->sizeChanged();
             }
@@ -94,5 +94,5 @@
             inline void setAimMarkerSize(float size)
             {
-                aimMarkerSize_ = size;
+                this->aimMarkerSize_ = size;
                 this->sizeChanged();
             }