Index: /branches/proxy/src/lib/network/monitor/network_monitor.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9444)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9445)
@@ -179,5 +179,5 @@
  * @returns the proxy server of the first choice
  */
-PeerInfo* NetworkMonitor::getFirstChoiceProxy()
+PeerInfo* NetworkMonitor::getFirstChoiceProxy() const
 {
   // return the fist proxy in the list
@@ -189,5 +189,5 @@
  * @returns the proxy server of second choice
  */
-PeerInfo* NetworkMonitor::getSecondChoiceProxy()
+PeerInfo* NetworkMonitor::getSecondChoiceProxy() const
 {
   // return the second server in the list
Index: /branches/proxy/src/lib/network/monitor/network_monitor.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9444)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9445)
@@ -55,24 +55,25 @@
     inline void removeMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->removeMasterServer(pInfo); }
 
-    PeerInfo* getFirstChoiceProxy();
-    PeerInfo* getSecondChoiceProxy();
+    PeerInfo* getFirstChoiceProxy() const;
+    PeerInfo* getSecondChoiceProxy() const;
     /** @returns the local node */
     inline NetworkNode* getLocalNode() const { return this->localNode; };
 
     /** @returns the active proxy server list of the localnode */
-    inline std::list<PeerInfo*> getActiveProxyServer() { return this->localNode->getActiveProxyServer(); }
+    inline std::list<PeerInfo*> getActiveProxyServer() const { return this->localNode->getActiveProxyServer(); }
 
     /* slots admin and info interface */
     /** @returns the total number of players in this game (including all proxy servers etc)*/
-    inline int getPlayerNumber() { return this->playerNumber; }
+    inline int getPlayerNumber() const { return this->playerNumber; }
 
     /** @returns true if there are still free network slots available at the local node*/
-    inline bool gotFreeSlots() { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool gotFreeSlots() const { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer()); }
     /** @param node node to be checked for slots @returns true if there are still free network slots available at this node */
-    inline bool gotFreeSlots(NetworkNode* node) { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool gotFreeSlots(NetworkNode* node) const { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer()); }
 
     /** @returns true if the next client should be reconnected to some other proxy server with more connections */
-    inline bool isReconnectNextClient() { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool isReconnectNextClient() const { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer()); }
 
+    inline const std::list<NetworkNode*>& getNodeList() const { return this->nodeList; };
 
     void toggleGUI();
Index: /branches/proxy/src/lib/network/peer_info.cc
===================================================================
--- /branches/proxy/src/lib/network/peer_info.cc	(revision 9444)
+++ /branches/proxy/src/lib/network/peer_info.cc	(revision 9445)
@@ -54,7 +54,8 @@
 
 
-const std::string& PeerInfo::getNodeTypeString()
+const std::string& PeerInfo::getNodeTypeString() const
 {
-  return nodeNames[this->nodeType];
+  return PeerInfo::nodeTypeToString( this->nodeType );
+  // the above does the same, and is faster in it. (there is no case where node is uninit i hope!)
 /*
   switch( this->nodeType)
@@ -73,4 +74,10 @@
 }
 
+const std::string& PeerInfo::nodeTypeToString(unsigned int type)
+{
+  return PeerInfo::nodeNames[type];
+}
+
+
 const std::string PeerInfo::nodeNames[] =
 {
Index: /branches/proxy/src/lib/network/peer_info.h
===================================================================
--- /branches/proxy/src/lib/network/peer_info.h	(revision 9444)
+++ /branches/proxy/src/lib/network/peer_info.h	(revision 9445)
@@ -27,5 +27,6 @@
     inline bool isClient() const { return this->nodeType == NET_CLIENT; }
 
-    const std::string& getNodeTypeString();
+    const std::string& getNodeTypeString() const;
+    static const std::string& nodeTypeToString(unsigned int type);
 
 