Index: branches/proxy/src/lib/network/monitor/network_monitor.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9450)
+++ branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9451)
@@ -240,5 +240,5 @@
  * prints out the debug informations
  */
-void NetworkMonitor::debug()
+void NetworkMonitor::debug() const
 {
   PRINT(0)("================================= Network Monitor::debug() =====\n");
@@ -248,5 +248,5 @@
   PRINT(0)(" Max players on this server: %i\n", SharedNetworkData::getInstance()->getMaxPlayer());
 
-  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  std::list<NetworkNode*>::const_iterator it = this->nodeList.begin();
   for(; it != this->nodeList.end(); it++)
   {
Index: branches/proxy/src/lib/network/monitor/network_monitor.h
===================================================================
--- branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9450)
+++ branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9451)
@@ -80,5 +80,5 @@
 
     void process();
-    void debug();
+    void debug() const;
 
 
Index: branches/proxy/src/lib/network/monitor/network_node.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9450)
+++ branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9451)
@@ -152,10 +152,10 @@
  * @return the client in the list or NULL if none
  */
-PeerInfo* NetworkNode::getClient(int index)
+PeerInfo* NetworkNode::getClient(int index) const
 {
   if( this->clientList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->clientList.begin();
   for(int i = 0; it != this->clientList.end(); it++, i++)
   {
@@ -172,10 +172,10 @@
  * @return the active proxy server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getActiveProxyServer(int index)
+PeerInfo* NetworkNode::getActiveProxyServer(int index) const
 {
   if( this->activeProxyServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->activeProxyServerList.begin();
   for(int i = 0; it != this->activeProxyServerList.end(); it++, i++)
   {
@@ -192,10 +192,10 @@
  * @return the passive proxy server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getPassiveProxyServer(int index)
+PeerInfo* NetworkNode::getPassiveProxyServer(int index) const
 {
   if( this->passiveProxyServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->passiveProxyServerList.begin();
   for(int i = 0; it != this->passiveProxyServerList.end(); it++, i++)
   {
@@ -212,10 +212,10 @@
  * @return the master server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getMasterServer(int index)
+PeerInfo* NetworkNode::getMasterServer(int index) const
 {
   if( this->masterServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->masterServerList.begin();
   for(int i = 0; it != this->masterServerList.end(); it++, i++)
   {
@@ -232,10 +232,10 @@
  * @param depth: depth in the tree
  */
-void NetworkNode::debug(int depth)
+void NetworkNode::debug(int depth) const
 {
   PRINT(0)(" = %s\n", this->peerInfo->getNodeTypeString().c_str());
 
   PRINT(0)("    master servers: %i\n", this->masterServerList.size());
-  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->masterServerList.begin();
   for(; it != this->masterServerList.end(); it++)
   {
Index: branches/proxy/src/lib/network/monitor/network_node.h
===================================================================
--- branches/proxy/src/lib/network/monitor/network_node.h	(revision 9450)
+++ branches/proxy/src/lib/network/monitor/network_node.h	(revision 9451)
@@ -32,27 +32,27 @@
     void removeMasterServer(PeerInfo* node);
 
-    PeerInfo* getClient(int index);
-    PeerInfo* getActiveProxyServer(int index);
-    PeerInfo* getPassiveProxyServer(int index);
-    PeerInfo* getMasterServer(int index);
+    PeerInfo* getClient(int index) const;
+    PeerInfo* getActiveProxyServer(int index) const;
+    PeerInfo* getPassiveProxyServer(int index) const;
+    PeerInfo* getMasterServer(int index) const;
 
     /** @returns the master server list */
-    inline std::list<PeerInfo*> getMasterServer() { return this->masterServerList; }
+    inline std::list<PeerInfo*> getMasterServer() const { return this->masterServerList; }
     /** @returns the active proxy server list */
-    inline std::list<PeerInfo*> getActiveProxyServer() { return this->activeProxyServerList; }
+    inline std::list<PeerInfo*> getActiveProxyServer() const { return this->activeProxyServerList; }
     /** @returns the passive proxy server list */
-    inline std::list<PeerInfo*> getPassiveProxyServer() { return this->passiveProxyServerList; }
+    inline std::list<PeerInfo*> getPassiveProxyServer() const { return this->passiveProxyServerList; }
     /** @returns the client list */
-    inline std::list<PeerInfo*> getClient() { return this->clientList; }
+    inline std::list<PeerInfo*> getClient() const { return this->clientList; }
 
 
     /** @returns the number of players */
-    inline int getPlayerNumber() { return this->playerNumber; }
+    inline int getPlayerNumber() const { return this->playerNumber; }
     /** @returns the node type of this node */
-    inline int getNodeType() { return this->peerInfo->nodeType; }
+    inline int getNodeType() const { return this->peerInfo->nodeType; }
     /** @returns the peer info of this node */
-    inline PeerInfo* getPeerInfo() { return this->peerInfo; }
+    inline PeerInfo* getPeerInfo() const { return this->peerInfo; }
 
-    void debug(int depth);
+    void debug(int depth) const;
 
 